## qmmp 1.4.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
project(qmmp)

#freebsd support
include_directories(SYSTEM /usr/local/include)
SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /usr/local/include)

#macports support
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /opt/local/include)
ENDIF()

IF(POLICY CMP0071)
  cmake_policy(SET CMP0071 NEW)
ENDIF()

IF(POLICY CMP0063)
cmake_policy(SET CMP0063 NEW)
ENDIF()

#Qt5 modules
SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} /home/user/qt514/lib/cmake)

#installation paths
include(GNUInstallDirs)

#extract version from qmmp.h
FILE(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/qmmp/qmmp.h"
     QMMP_VERSION_DATA REGEX "^#define[ \t]+QMMP_VERSION_[A-Z]+[ \t]+[0-9]+.*$")

IF(QMMP_VERSION_DATA)
   FOREACH(item IN ITEMS MAJOR MINOR PATCH STABLE)
      STRING(REGEX REPLACE ".*#define[ \t]+QMMP_VERSION_${item}[ \t]+([0-9]+).*"
       "\\1" QMMP_VERSION_${item} ${QMMP_VERSION_DATA})
   ENDFOREACH(item IN ITEMS MAJOR MINOR PATCH)
   SET(QMMP_VERSION "${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}.${QMMP_VERSION_PATCH}")
   SET(QMMP_SOVERSION "${QMMP_VERSION_MAJOR}")
   IF(QMMP_VERSION_STABLE)
      MESSAGE(STATUS "Qmmp API version: ${QMMP_VERSION} (stable)")
   ELSE(QMMP_VERSION_STABLE)
      MESSAGE(STATUS "Qmmp API version: ${QMMP_VERSION} (development)")
   ENDIF(QMMP_VERSION_STABLE)
ELSE(QMMP_VERSION_DATA)
   MESSAGE(FATAL_ERROR "invalid header")
ENDIF(QMMP_VERSION_DATA)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

INCLUDE(FindPkgConfig)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
find_package(Qt5Widgets 5.4.0 REQUIRED)
find_package(Qt5LinguistTools 5.4.0 REQUIRED)
find_package(Qt5Network 5.4.0 REQUIRED)
find_package(Qt5X11Extras 5.4.0)
find_package(Qt5DBus 5.4.0)
find_package(Qt5Multimedia 5.4.0)
find_package(Qt5Sql 5.4.0)
find_package(Qt5WinExtras 5.4.0)
ADD_DEFINITIONS(-DQMMP_WS_X11 -DQT_DISABLE_DEPRECATED_BEFORE=0x050400 -DQT_DEPRECATED_WARNINGS)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_CXX_STANDARD 11)

get_target_property(QT_LRELEASE_EXECUTABLE Qt5::lrelease IMPORTED_LOCATION)

IF(QT_LRELEASE_EXECUTABLE)
MESSAGE(STATUS "Found lrelease executable: " ${QT_LRELEASE_EXECUTABLE})
ELSE(QT_LRELEASE_EXECUTABLE)
MESSAGE(FATAL_ERROR "Could NOT find lrelease executable")
ENDIF(QT_LRELEASE_EXECUTABLE)

MESSAGE(STATUS "Generating translations ...")
IF(SVN_VERSION)
execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent -nounfinished)
ELSE(SVN_VERSION)
execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
ENDIF(SVN_VERSION)

get_target_property(QT_LIBRARY_DIR Qt5::Core LOCATION)
get_filename_component(QT_LIBRARY_DIR ${QT_LIBRARY_DIR} PATH)

SET(PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qmmp-${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}" CACHE STRING "plugin path")
SET(USE_SKINNED TRUE CACHE BOOL "enable/disable standard skinned user interface")
SET(USE_DIR_ASSOC TRUE CACHE BOOL "enable/disable inode/directory mime type association")
#SET(APP_NAME_SUFFIX "-1")

pkg_search_module(X11 x11)

add_subdirectory(src/qmmp)
add_subdirectory(src/qmmpui)
add_subdirectory(src/plugins)
add_subdirectory(src/app)
add_subdirectory(doc)

IF(MAD_FOUND)
  SET(MPEG_DECODERS "MAD")
ENDIF(MAD_FOUND)

IF(MPG123_FOUND)
  SET(MPEG_DECODERS ${MPEG_DECODERS} "mpg123")
ENDIF(MPG123_FOUND)

MACRO(PRINT_SUMMARY str USE FOUND)
IF(${USE} AND ${FOUND})
MESSAGE("${str}enabled")
ELSE(${USE} AND ${FOUND})
MESSAGE("${str}disabled")
ENDIF(${USE} AND ${FOUND})
ENDMACRO(PRINT_SUMMARY)

IF (UNIX)
ADD_CUSTOM_TARGET (distclean @echo cleaning for source distribution)

ADD_CUSTOM_COMMAND(
    COMMENT "distribution clean"
    COMMAND make
    ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeCache.txt" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeFiles" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "Makefile" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name \"*.cmake\" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_SOURCE_DIR} -name "*.qm" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.pc" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.depends" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.cxx_parameters" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "moc_*.cpp" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "qrc_*.cxx" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*_automoc.cpp" | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name *_automoc.dir | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/doc/html
    TARGET  distclean
)
ENDIF(UNIX)


MESSAGE("")
MESSAGE("Transports:")
PRINT_SUMMARY ("HTTP support .........................." USE_CURL CURL_FOUND)
PRINT_SUMMARY ("MMS support ..........................." USE_MMS MMS_FOUND)

MESSAGE("")
MESSAGE("Input Plugins:")
PRINT_SUMMARY ("MPEG support .........................." 1 MAD_FOUND OR MPG123_FOUND)
PRINT_SUMMARY ("FLAC support .........................." USE_FLAC FLAC_FOUND)
PRINT_SUMMARY ("Ogg Vorbis support ...................." USE_VORBIS VORBIS_FOUND)
PRINT_SUMMARY ("Musepack support ......................" USE_MPC MPC_FOUND)
PRINT_SUMMARY ("MOD support ..........................." USE_MODPLUG MODPLUG_FOUND)
PRINT_SUMMARY ("Wave support .........................." USE_SNDFILE SNDFILE_FOUND)
PRINT_SUMMARY ("WavPack support ......................." USE_WAVPACK WAVPACK_FOUND)
PRINT_SUMMARY ("FFmpeg support ........................" USE_FFMPEG FFMPEG_FOUND)
PRINT_SUMMARY ("AAC support ..........................." USE_AAC FAAD_FOUND)
PRINT_SUMMARY ("CUE sheet support ....................." USE_CUE 1)
PRINT_SUMMARY ("Mplayer support ......................." USE_MPLAYER 1)
PRINT_SUMMARY ("CD Audio support ......................" USE_CDA CDIO_FOUND)
PRINT_SUMMARY ("Midi support .........................." USE_MIDI WILDMIDI_FOUND)
PRINT_SUMMARY ("Game music support ...................." USE_GME GME_FOUND)
PRINT_SUMMARY ("Ogg Opus support ......................" USE_OPUS OPUS_FOUND)
PRINT_SUMMARY ("SID support ..........................." USE_SID SIDPLAYFP_FOUND)
PRINT_SUMMARY ("Archive support ......................." USE_ARCHIVE LIBARCHIVE_FOUND)

MESSAGE("")
MESSAGE("Output Plugins:")
PRINT_SUMMARY ("ALSA support .........................." USE_ALSA ALSA_FOUND)
PRINT_SUMMARY ("OSS support ..........................." USE_OSS 1)
PRINT_SUMMARY ("OSS4 support .........................." USE_OSS4 OSS4_FOUND)
PRINT_SUMMARY ("JACK support .........................." USE_JACK JACK_FOUND)
PRINT_SUMMARY ("PulseAudio support ...................." USE_PULSE PULSE_FOUND)
PRINT_SUMMARY ("Null output support ..................." USE_NULL 1)
PRINT_SUMMARY ("Waveout support (Windows) ............." USE_WAVEOUT WINDOWS_H_FOUND)
PRINT_SUMMARY ("DirectSound support (Windows) ........." USE_DSOUND DSOUND_H_FOUND)
PRINT_SUMMARY ("WASAPI support (Windows) .............." USE_WASAPI WASAPI_FOUND)
PRINT_SUMMARY ("Qt Multimedia support ................." USE_QTMULTIMEDIA Qt5Multimedia_FOUND)
PRINT_SUMMARY ("Icecast support ......................." USE_SHOUT SHOUT_FOUND)

MESSAGE("")
MESSAGE("Effect Plugins:")
PRINT_SUMMARY ("SoX Resampler ........................." USE_SOXR SOXR_FOUND)
PRINT_SUMMARY ("BS2B Plugin ..........................." USE_BS2B BS2B_FOUND)
PRINT_SUMMARY ("LADSPA Host ..........................." USE_LADSPA 1)
PRINT_SUMMARY ("Crossfade ............................." USE_CROSSFADE 1)
PRINT_SUMMARY ("Extra Stereo .........................." USE_STEREO 1)
PRINT_SUMMARY ("File Writer ..........................." USE_FILEWRITER VORBISENC_FOUND)
PRINT_SUMMARY ("Mono to Stereo Converter .............." USE_MONOTOSTEREO 1)

MESSAGE("")
MESSAGE("Visual Plugins:")
PRINT_SUMMARY ("Analyzer .............................." USE_ANALYZER 1)
PRINT_SUMMARY ("ProjectM .............................." USE_PROJECTM PROJECTM_FOUND)

MESSAGE("")
MESSAGE("General Plugins:")
PRINT_SUMMARY ("MPRIS support ........................." USE_MPRIS Qt5DBus_FOUND)
PRINT_SUMMARY ("Scrobbler ............................." USE_SCROBBLER 1)
PRINT_SUMMARY ("ListenBrainz .........................." USE_LISTENBRAINZ 1)
PRINT_SUMMARY ("Tray support .........................." USE_STATICON 1)
PRINT_SUMMARY ("Notifier support ......................" USE_NOTIFIER 1)
PRINT_SUMMARY ("Lyrics support ........................" USE_LYRICS 1)
PRINT_SUMMARY ("HAL support ..........................." USE_HAL Qt5DBus_FOUND)
PRINT_SUMMARY ("UDisks2 support ......................." USE_UDISKS2 Qt5DBus_FOUND)
PRINT_SUMMARY ("Global hotkey support ................." USE_HOTKEY X11_FOUND AND XCB_H_FOUND AND Qt5X11Extras_FOUND)
PRINT_SUMMARY ("GNOME/Cinnamon hotkey support ........." USE_GNOMEHOTKEY Qt5DBus_FOUND)
PRINT_SUMMARY ("File operations ......................." USE_FILEOPS 1)
PRINT_SUMMARY ("Cover manager ........................." USE_COVER 1)
PRINT_SUMMARY ("KDE notifications support ............." USE_KDENOTIFY Qt5DBus_FOUND)
PRINT_SUMMARY ("Audio converter ......................." USE_CONVERTER TAGLIB_FOUND)
PRINT_SUMMARY ("ReplayGain Scanner ...................." USE_RGSCAN TAGLIB_FOUND)
PRINT_SUMMARY ("Stream browser ........................" USE_SB 1)
PRINT_SUMMARY ("Track change .........................." USE_TRACKCHANGE 1)
PRINT_SUMMARY ("Copy/Paste ............................" USE_COPYPASTE 1)
PRINT_SUMMARY ("History plugin ........................" USE_HISTORY Qt5Sql_FOUND)
PRINT_SUMMARY ("Sleep mode inhibition plugin .........." USE_SLEEPINHIBITOR Qt5DBus_FOUND)
PRINT_SUMMARY ("Taskbar plugin (Windows) .............." USE_TASKBAR Qt5WinExtras_FOUND)
PRINT_SUMMARY ("Removable device detection (Windows) .." USE_RDETECT Qt5WinExtras_FOUND)

MESSAGE("")
MESSAGE("File Dialogs:")
PRINT_SUMMARY ("QMMP File Dialog ......................" USE_QMMP_DIALOG 1)
PRINT_SUMMARY ("Two-panel File File Dialog ............" USE_TWO_PANEL_DIALOG 1)

MESSAGE("")
MESSAGE("Advanced:")
PRINT_SUMMARY ("Skinned user interface ................" USE_SKINNED X11_FOUND AND Qt5X11Extras_FOUND)
PRINT_SUMMARY ("Simple user interface (QSUI) .........." USE_QSUI 1)
PRINT_SUMMARY ("Automatic charset detection ..........." USE_ENCA ENCA_FOUND)
PRINT_SUMMARY ("Directory association ................." USE_DIR_ASSOC 1)
PRINT_SUMMARY ("Set RPATH in installed binaries ......." CMAKE_INSTALL_RPATH_USE_LINK_PATH 1)
IF(MPEG_DECODERS)
MESSAGE       ("MPEG decoders ........................." "${MPEG_DECODERS}")
ENDIF(MPEG_DECODERS)

MESSAGE("")

=== src/app/CMakeLists.txt ===
project(app)

INCLUDE(UsePkgConfig)

ADD_DEFINITIONS( -Wall )
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_THREAD)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})


# libqmmp & libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

link_directories(${CMAKE_INSTALL_PREFIX}/${LIB_DIR})
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmp)

SET(app_SRCS
    builtincommandlineoption.cpp
    main.cpp
    qmmpstarter.cpp
)

SET(app_RCCS images/images.qrc translations/qmmp_locales.qrc)

QT5_ADD_RESOURCES(app_RCC_SRCS ${app_RCCS})

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_EXECUTABLE(qmmp ${app_SRCS} ${app_RCC_SRCS})
target_link_libraries(qmmp Qt5::Widgets libqmmp libqmmpui)
SET_TARGET_PROPERTIES(qmmp PROPERTIES OUTPUT_NAME qmmp${APP_NAME_SUFFIX})
add_dependencies(qmmp libqmmpui libqmmp)

install(TARGETS qmmp DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES qmmp-opencda${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/solid/actions)
install(FILES qmmp${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(FILES images/16x16/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps)
install(FILES images/32x32/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
install(FILES images/48x48/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps)
install(FILES images/56x56/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/56x56/apps)
install(FILES images/64x64/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)
install(FILES images/128x128/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps)
install(FILES images/256x256/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps)
install(FILES images/scalable/qmmp${APP_NAME_SUFFIX}.svgz images/scalable/qmmp-simple${APP_NAME_SUFFIX}.svgz DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
install(FILES appdata/qmmp${APP_NAME_SUFFIX}.appdata.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

IF(USE_DIR_ASSOC)
    install(FILES qmmp-enqueue${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES qmmp-dir${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
ENDIF(USE_DIR_ASSOC)

=== src/plugins/CMakeLists.txt ===
SET(USE_ENCA TRUE CACHE BOOL "enable/disable libenca support")
include(FindPkgConfig)
pkg_search_module(ENCA enca>=1.9)
pkg_search_module(TAGLIB taglib>=1.10)
add_subdirectory(Input)
add_subdirectory(Output)
add_subdirectory(Visual)
add_subdirectory(Effect)
add_subdirectory(General)
add_subdirectory(PlayListFormats)
add_subdirectory(CommandLineOptions)
add_subdirectory(FileDialogs)
add_subdirectory(Transports)
add_subdirectory(Engines)
add_subdirectory(Ui)

=== src/qmmpui/CMakeLists.txt ===
project(libqmmpui)

ADD_DEFINITIONS(-DQMMPUI_LIBRARY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# libqmmp
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

link_directories(${CMAKE_INSTALL_PREFIX}/${LIB_DIR})
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmp)

SET(QMMP_DEFAULT_UI "" CACHE STRING "default user interface")
IF(QMMP_DEFAULT_UI)
    SET(libqmmpui_DEFINES ${libqmmpui_DEFINES} QMMP_DEFAULT_UI="${QMMP_DEFAULT_OUTPUT}")
    MESSAGE(STATUS "Default user interface: ${QMMP_DEFAULT_UI}")
ENDIF(QMMP_DEFAULT_UI)


SET(libqmmpui_SRCS
    general.cpp
    uihelper.cpp
    playlistparser.cpp
    commandlinemanager.cpp
    commandlinehandler.cpp
    filedialog.cpp
    qtfiledialog.cpp
    fileloader.cpp
    playstate.cpp
    playlistmodel.cpp
    playlistitem.cpp
    playlistgroup.cpp
    playlisttrack.cpp
    playlistcontainer.cpp
    normalcontainer.cpp
    groupedcontainer.cpp
    mediaplayer.cpp
    detailsdialog.cpp
    tageditor.cpp
    playlistmanager.cpp
    metadataformatter.cpp
    metadataformattermenu.cpp
    templateeditor.cpp
    uiloader.cpp
    jumptotrackdialog.cpp
    configdialog.cpp
    pluginitem.cpp
    aboutdialog.cpp
    qmmpuisettings.cpp
    radioitemdelegate.cpp
    playlistdownloader.cpp
    addurldialog.cpp
    qmmpuiplugincache.cpp
    tagupdater.cpp
    playlisttask.cpp
    playlistheadermodel.cpp
    columneditor.cpp
    metadatahelper.cpp
    coverviewer.cpp
    covereditor.cpp
)

SET(libqmmpui_HDRS
    generalfactory.h
    playlistformat.h
    commandlinemanager.h
    commandlinehandler.h
    filedialogfactory.h
    playstate_p.h
    playlistitem.h
    playlistgroup.h
    playlisttrack.h
    playlistcontainer_p.h
    normalcontainer_p.h
    groupedcontainer_p.h
    metadataformatter.h
    metadataformattermenu.h
    uiloader.h
    uifactory.h
    pluginitem_p.h
    general.h
    playlistparser.h
    qmmpuiplugincache_p.h
    metadatahelper_p.h
    qmmpui_export.h
)

SET(libqmmpui_DEVEL_HDRS
    commandlinemanager.h
    commandlinehandler.h
    configdialog.h
    detailsdialog.h
    filedialogfactory.h
    filedialog.h
    generalfactory.h
    general.h
    mediaplayer.h
    metadataformatter.h
    metadataformattermenu.h
    playlistdownloader.h
    playlistformat.h
    playlistitem.h
    playlistgroup.h
    playlisttrack.h
    playlistmanager.h
    playlistmodel.h
    playlistparser.h
    qmmpuisettings.h
    templateeditor.h
    uifactory.h
    uihelper.h
    uiloader.h
    playlistheadermodel.h
    qmmpui_export.h
)


SET(libqmmpui_UIS
    forms/detailsdialog.ui
    forms/tageditor.ui
    forms/templateeditor.ui
    forms/jumptotrackdialog.ui
    forms/configdialog.ui
    forms/aboutdialog.ui
    forms/addurldialog.ui
    forms/columneditor.ui
    forms/covereditor.ui
)

QT5_WRAP_UI(libqmmpui_UIS_H ${libqmmpui_UIS})

QT5_ADD_RESOURCES(libqmmpui_RCC_SRCS translations/libqmmpui_locales.qrc txt/txt.qrc images/qmmpui_images.qrc)

include_directories(${CMAKE_CURRENT_BINARY_DIR})


ADD_LIBRARY(libqmmpui SHARED ${libqmmpui_SRCS} ${libqmmpui_RCC_SRCS} ${libqmmpui_UIS_H} ${libqmmpui_HDRS})
target_link_libraries(libqmmpui Qt5::Widgets Qt5::Network libqmmp)
add_dependencies(libqmmpui libqmmp)
SET_TARGET_PROPERTIES(libqmmpui PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmpui${APP_NAME_SUFFIX})
target_compile_definitions(libqmmpui PRIVATE ${libqmmpui_DEFINES})
install(TARGETS libqmmpui LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})


IF(APP_NAME_SUFFIX)
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX}/qmmpui)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX})
ELSE()
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmpui)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
ENDIF()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmpui.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/plugins/CommandLineOptions/CMakeLists.txt ===
add_subdirectory(IncDecVolumeOption)
add_subdirectory(SeekOption)
add_subdirectory(StatusOption)
add_subdirectory(PlayListOption)

=== src/plugins/Effect/CMakeLists.txt ===
SET(USE_SOXR TRUE CACHE BOOL "enable/disable SoX resampler plugin")
SET(USE_BS2B TRUE CACHE BOOL "enable/disable bs2b plugin")
SET(USE_LADSPA TRUE CACHE BOOL "enable/disable ladspa plugin")
SET(USE_CROSSFADE TRUE CACHE BOOL "enable/disable crossfade plugin")
SET(USE_STEREO TRUE CACHE BOOL "enable/disable extra stereo plugin")
SET(USE_FILEWRITER TRUE CACHE BOOL "enable/disable file writer plugin")
SET(USE_MONOTOSTEREO TRUE CACHE BOOL "enable/disable mono to stereo converter plugin")

IF(USE_SOXR)
add_subdirectory(soxr)
ENDIF(USE_SOXR)

IF(USE_BS2B)
add_subdirectory(bs2b)
ENDIF(USE_BS2B)

IF(USE_LADSPA)
add_subdirectory(ladspa)
ENDIF(USE_LADSPA)

IF(USE_CROSSFADE)
add_subdirectory(crossfade)
ENDIF(USE_CROSSFADE)

IF(USE_STEREO)
add_subdirectory(stereo)
ENDIF(USE_STEREO)

IF(USE_FILEWRITER)
add_subdirectory(filewriter)
ENDIF(USE_FILEWRITER)

IF(USE_MONOTOSTEREO)
add_subdirectory(monotostereo)
ENDIF(USE_MONOTOSTEREO)

=== src/plugins/Engines/CMakeLists.txt ===
SET(USE_MPLAYER TRUE CACHE BOOL "enable/disable mplayer support")

IF(USE_MPLAYER)
add_subdirectory(mplayer)
ENDIF(USE_MPLAYER)

=== src/plugins/General/CMakeLists.txt ===
SET(USE_MPRIS TRUE CACHE BOOL "enable/disable mpris plugin")
SET(USE_SCROBBLER TRUE CACHE BOOL "enable/disable scrobbler plugin")
SET(USE_LISTENBRAINZ TRUE CACHE BOOL "enable/disable listenbrainz plugin")
SET(USE_STATICON TRUE CACHE BOOL "enable/disable status icon plugin")
SET(USE_NOTIFIER TRUE CACHE BOOL "enable/disable notifier plugin")
SET(USE_LYRICS TRUE CACHE BOOL "enable/disable lyrics version")
SET(USE_HAL (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD") CACHE BOOL "enable/disable hal plugin")
SET(USE_UDISKS2 TRUE CACHE BOOL "enable/disable udisks2 plugin")
SET(USE_HOTKEY TRUE CACHE BOOL "enable/disable global hotkey plugin")
SET(USE_GNOMEHOTKEY TRUE CACHE BOOL "enable/disable gnome hotkey plugin")
SET(USE_FILEOPS TRUE CACHE BOOL "enable/disable fileops plugin")
SET(USE_COVER TRUE CACHE BOOL "enable/disable cover manager plugin")
SET(USE_KDENOTIFY TRUE CACHE BOOL "enable/disable kde notification plugin")
SET(USE_CONVERTER TRUE CACHE BOOL "enable/disable audio converter plugin")
SET(USE_RGSCAN TRUE CACHE BOOL "enable/disable replaygain scanner plugin")
SET(USE_SB TRUE CACHE BOOL "enable/disable stream browser plugin")
SET(USE_TRACKCHANGE TRUE CACHE BOOL "enable/disable track change plugin")
SET(USE_COPYPASTE TRUE CACHE BOOL "enable/disable copy/paste change plugin")
SET(USE_HISTORY TRUE CACHE BOOL "enable/disable history plugin")
SET(USE_SLEEPINHIBITOR TRUE CACHE BOOL "enable/disable sleep mode inhibition plugin")
SET(USE_TASKBAR TRUE CACHE BOOL "enable/disable taskbar plugin (Windows)")
SET(USE_RDETECT TRUE CACHE BOOL "enable/disable rdetect plugin (Windows)")

IF(USE_MPRIS AND Qt5DBus_FOUND)
add_subdirectory(mpris)
ENDIF(USE_MPRIS AND Qt5DBus_FOUND)

IF(USE_SCROBBLER)
add_subdirectory(scrobbler)
ENDIF(USE_SCROBBLER)

IF(USE_LISTENBRAINZ)
add_subdirectory(listenbrainz)
ENDIF(USE_LISTENBRAINZ)

IF(USE_STATICON)
add_subdirectory(statusicon)
ENDIF(USE_STATICON)

IF(USE_NOTIFIER)
add_subdirectory(notifier)
ENDIF(USE_NOTIFIER)

IF(USE_LYRICS)
add_subdirectory(lyrics)
ENDIF(USE_LYRICS)

IF(USE_HAL AND Qt5DBus_FOUND)
add_subdirectory(hal)
ENDIF(USE_HAL AND Qt5DBus_FOUND)

IF(USE_UDISKS2 AND Qt5DBus_FOUND)
add_subdirectory(udisks2)
ENDIF(USE_UDISKS2 AND Qt5DBus_FOUND)

IF(USE_HOTKEY AND Qt5X11Extras_FOUND)
add_subdirectory(hotkey)
ENDIF(USE_HOTKEY AND Qt5X11Extras_FOUND)

IF(USE_FILEOPS)
add_subdirectory(fileops)
ENDIF(USE_FILEOPS)

IF(USE_COVER)
add_subdirectory(covermanager)
ENDIF(USE_COVER)

IF(USE_KDENOTIFY AND Qt5DBus_FOUND)
add_subdirectory(kdenotify)
ENDIF(USE_KDENOTIFY AND Qt5DBus_FOUND)

IF(USE_CONVERTER AND TAGLIB_FOUND)
add_subdirectory(converter)
ENDIF(USE_CONVERTER AND TAGLIB_FOUND)

IF(USE_RGSCAN AND TAGLIB_FOUND)
add_subdirectory(rgscan)
ENDIF(USE_RGSCAN AND TAGLIB_FOUND)

IF(USE_SB)
add_subdirectory(streambrowser)
ENDIF(USE_SB)

IF(USE_TRACKCHANGE)
add_subdirectory(trackchange)
ENDIF(USE_TRACKCHANGE)

IF(USE_COPYPASTE)
add_subdirectory(copypaste)
ENDIF(USE_COPYPASTE)

IF(USE_GNOMEHOTKEY AND Qt5DBus_FOUND)
add_subdirectory(gnomehotkey)
ENDIF(USE_GNOMEHOTKEY AND Qt5DBus_FOUND)

IF(USE_HISTORY AND Qt5Sql_FOUND)
add_subdirectory(history)
ENDIF(USE_HISTORY AND Qt5Sql_FOUND)

IF(USE_SLEEPINHIBITOR AND Qt5DBus_FOUND)
add_subdirectory(sleepinhibitor)
ENDIF(USE_SLEEPINHIBITOR AND Qt5DBus_FOUND)

IF(USE_TASKBAR AND Qt5WinExtras_FOUND)
add_subdirectory(taskbar)
ENDIF(USE_TASKBAR AND Qt5WinExtras_FOUND)

IF(USE_RDETECT AND Qt5WinExtras_FOUND)
add_subdirectory(rdetect)
ENDIF(USE_RDETECT AND Qt5WinExtras_FOUND)

=== src/plugins/Input/CMakeLists.txt ===
SET(USE_MAD            TRUE CACHE BOOL "enable/disable mad decoder (mpeg plugin)")
SET(USE_MPG123         TRUE CACHE BOOL "enable/disable mpg123 decoder (mpeg plugin)")
SET(USE_FLAC           TRUE CACHE BOOL "enable/disable flac plugin")
SET(USE_VORBIS         TRUE CACHE BOOL "enable/disable ogg vorbis plugin")
SET(USE_FFMPEG         TRUE CACHE BOOL "enable/disable ffmpeg plugin")
SET(USE_MPC            TRUE CACHE BOOL "enable/disable mpc plugin")
SET(USE_SNDFILE        TRUE CACHE BOOL "enable/disable sndfile plugin")
SET(USE_WAVPACK        TRUE CACHE BOOL "enable/disable wavpack plugin")
SET(USE_MODPLUG        TRUE CACHE BOOL "enable/disable modplug plugin")
SET(USE_AAC            TRUE CACHE BOOL "enable/disable aac plugin")
SET(USE_CUE            TRUE CACHE BOOL "enable/disable cue plugin")
SET(USE_CDA            TRUE CACHE BOOL "enable/disable cd audio support")
SET(USE_MIDI           TRUE CACHE BOOL "enable/disable midi support")
SET(USE_GME            TRUE CACHE BOOL "enable/disable game music plugin")
SET(USE_OPUS           TRUE CACHE BOOL "enable/disable opus plugin")
SET(USE_SID            TRUE CACHE BOOL "enable/disable sid plugin")
SET(USE_ARCHIVE        TRUE CACHE BOOL "enable/disable archive plugin")


IF((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)
add_subdirectory(mpeg)
ENDIF((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)

IF(USE_FLAC AND TAGLIB_FOUND)
add_subdirectory(flac)
ENDIF(USE_FLAC AND TAGLIB_FOUND)

IF(USE_VORBIS AND TAGLIB_FOUND)
add_subdirectory(vorbis)
ENDIF(USE_VORBIS AND TAGLIB_FOUND)

IF(USE_FFMPEG)
add_subdirectory(ffmpeg)
ENDIF(USE_FFMPEG)

IF(USE_MPC AND TAGLIB_FOUND)
add_subdirectory(mpc)
ENDIF(USE_MPC AND TAGLIB_FOUND)

IF(USE_SNDFILE)
add_subdirectory(sndfile)
ENDIF(USE_SNDFILE)

IF(USE_WAVPACK)
add_subdirectory(wavpack)
ENDIF(USE_WAVPACK)

IF(USE_MODPLUG)
add_subdirectory(modplug)
ENDIF(USE_MODPLUG)

IF(USE_AAC AND TAGLIB_FOUND)
add_subdirectory(aac)
ENDIF(USE_AAC AND TAGLIB_FOUND)

IF(USE_CUE)
add_subdirectory(cue)
ENDIF(USE_CUE)

IF(USE_CDA)
add_subdirectory(cdaudio)
ENDIF(USE_CDA)

IF(USE_MIDI)
add_subdirectory(wildmidi)
ENDIF(USE_MIDI)

IF(USE_GME)
add_subdirectory(gme)
ENDIF(USE_GME)

IF(USE_OPUS AND TAGLIB_FOUND)
add_subdirectory(opus)
ENDIF(USE_OPUS AND TAGLIB_FOUND)

IF(USE_SID)
add_subdirectory(sid)
ENDIF(USE_SID)

IF(USE_ARCHIVE AND TAGLIB_FOUND AND (NOT (TAGLIB_VERSION VERSION_LESS 1.11)))
add_subdirectory(archive)
ENDIF(USE_ARCHIVE AND TAGLIB_FOUND AND (NOT (TAGLIB_VERSION VERSION_LESS 1.11)))

=== src/plugins/Output/CMakeLists.txt ===
SET(USE_ALSA TRUE CACHE BOOL "enable/disable alsa plugin")
SET(USE_JACK TRUE CACHE BOOL "enable/disable jack plugin")
SET(USE_OSS FALSE CACHE BOOL "enable/disable oss plugin")
SET(USE_OSS4 TRUE CACHE BOOL "enable/disable oss4 plugin")
SET(USE_PULSE TRUE CACHE BOOL "enable/disable pulse audio plugin")
SET(USE_NULL TRUE CACHE BOOL "enable/disable null output plugin")
SET(USE_WAVEOUT TRUE CACHE BOOL "enable/disable Win32 waveout plugin")
SET(USE_DSOUND TRUE CACHE BOOL "enable/disable DirectSound plugin")
SET(USE_QTMULTIMEDIA TRUE CACHE BOOL "enable/disable Qt Multimedia output plugin")
SET(USE_WASAPI TRUE CACHE BOOL "enable/disable WASAPI plugin")
SET(USE_SHOUT TRUE CACHE BOOL "enable/disable Icecast plugin")

IF(USE_ALSA)
add_subdirectory(alsa)
ENDIF(USE_ALSA)

IF(USE_JACK)
add_subdirectory(jack)
ENDIF(USE_JACK)

IF(USE_OSS)
add_subdirectory(oss)
ENDIF(USE_OSS)

IF(USE_OSS4)
add_subdirectory(oss4)
ENDIF(USE_OSS4)

IF(USE_PULSE)
add_subdirectory(pulseaudio)
ENDIF(USE_PULSE)

IF(USE_NULL)
add_subdirectory(null)
ENDIF(USE_NULL)

IF(USE_WAVEOUT)
add_subdirectory(waveout)
ENDIF(USE_WAVEOUT)

IF(USE_DSOUND)
add_subdirectory(directsound)
ENDIF(USE_DSOUND)

IF(USE_QTMULTIMEDIA AND Qt5Multimedia_FOUND)
add_subdirectory(qtmultimedia)
ENDIF(USE_QTMULTIMEDIA AND Qt5Multimedia_FOUND)

IF(USE_WASAPI)
add_subdirectory(wasapi)
ENDIF(USE_WASAPI)

IF(USE_SHOUT)
add_subdirectory(shout)
ENDIF(USE_SHOUT)

=== src/plugins/CommandLineOptions/IncDecVolumeOption/CMakeLists.txt ===
project(libincdecvolumeoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libincdecvolumeoption_SRCS
    incdecvolumeoption.cpp
)

SET(libincdecvolumeoption_RCCS translations/translations.qrc)

QT5_ADD_RESOURCES(libincdecvolumeoption_RCC_SRCS ${libincdecvolumeoption_RCCS})


# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(incdecvolumeoption MODULE ${libincdecvolumeoption_SRCS}
           ${libincdecvolumeoption_RCC_SRCS})
add_dependencies(incdecvolumeoption libqmmpui)
target_link_libraries(incdecvolumeoption Qt5::Widgets libqmmpui libqmmp)
install(TARGETS incdecvolumeoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== src/plugins/CommandLineOptions/PlayListOption/CMakeLists.txt ===
project(libplaylistoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libplaylistoption_SRCS
    playlistoption.cpp
)

SET(libplaylistoption_RCCS translations/translations.qrc)

QT5_ADD_RESOURCES(libplaylistoption_RCC_SRCS ${libplaylistoption_RCCS})


# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(playlistoption MODULE ${libplaylistoption_SRCS}
           ${libplaylistoption_RCC_SRCS})
add_dependencies(playlistoption libqmmpui)
target_link_libraries(playlistoption Qt5::Widgets libqmmpui libqmmp)
install(TARGETS playlistoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== debian/changelog ===
qmmp (1.4.4-1) unstable; urgency=medium

  * New upstream version.

 -- Matteo Cypriani <mcy@lm7.fr>  Mon, 22 Feb 2021 21:02:09 +0100

qmmp (1.4.3-2) unstable; urgency=medium

  * qmmp-plugin-projectm architectures:
    + Cleaned up architecture list (added: ia64, ppc64, riscv64; removed:
      mips, powerpcspe)
    + Disabled for hurd.

 -- Matteo Cypriani <mcy@lm7.fr>  Sun, 17 Jan 2021 20:33:20 +0100

qmmp (1.4.3-1) unstable; urgency=medium

  * Acknowledging NMU.
  * Restored qmmp-plugin-projectm (projectm is back in Debian).
  * New upstream version.
    + Updated d/copyright.
    + Updated package description.
    + Updated qmmp.1 manpage.
  * Bump Standards-Version to 4.5.1 (no changes needed).
  * Bump dh compat to 13, quit using d/compat.
  * d/control: added Rules-Requires-Root field.
  * d/control: suggest ffmpeg.
  * Override lintian warning about "apparence".
  * d/rules: quit building with -Wl,--as-needed.
  * d/rules: install plugins in /usr/lib/qmmp/plugins/ rather than in
    /usr/lib/qmmp/qmmp/.

 -- Matteo Cypriani <mcy@lm7.fr>  Sun, 10 Jan 2021 13:20:17 +0100

=== debian/control ===
Source: qmmp
Section: sound
Priority: optional
Maintainer: Matteo Cypriani <mcy@lm7.fr>
Build-Depends: debhelper-compat (= 13), cmake, pkg-config, qtbase5-dev,
  libqt5x11extras5-dev, qttools5-dev, qttools5-dev-tools,
  qtchooser, libx11-dev, oss4-dev [!linux-any], libmad0-dev, libvorbis-dev,
  libogg-dev, libasound2-dev [linux-any], libtag1-dev (>= 1.10),
  libcurl4-gnutls-dev, qtmultimedia5-dev, libmms-dev,
  libflac-dev, libmpcdec-dev, libjack-jackd2-dev, libsoxr-dev,
  libmodplug-dev, libsndfile1-dev, libwavpack-dev, libpulse-dev,
  libavcodec-dev, libavformat-dev, libcdio-dev, libcdio-paranoia-dev,
  libcddb2-dev, libfaad-dev, libgme-dev, libopus-dev (>= 1.0.2),
  libopusfile-dev, libwildmidi-dev, libsidplayfp-dev (>= 1.0.3),
  libbs2b-dev, libprojectm-dev [!armel !armhf !hurd-any], libenca-dev,
  libarchive-dev (>= 3.2), libshout3-dev
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://qmmp.ylsoftware.com/
Vcs-Git: https://salsa.debian.org/debian/qmmp.git
Vcs-Browser: https://salsa.debian.org/debian/qmmp

Package: qmmp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: qmmp-plugin-projectm, ffmpeg, mplayer, unzip, udisks2 [linux-any],
  hal [!linux-any]
Replaces: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Breaks: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Description: feature-rich audio player with support of many formats
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 Supported formats:
  - MPEG1 layer 2/3
  - Ogg Vorbis
  - Ogg Opus
  - Native FLAC, Ogg FLAC
  - Musepack
  - WavePack
  - tracker modules (mod, s3m, it, xm, etc)
  - ADTS AAC
  - CD Audio
  - WMA, Monkey's Audio (and other formats provided by FFmpeg library)
  - PCM WAVE (and other formats provided by libsndfile library)
  - midi
  - SID
  - chiptune formats (AY, GBS, GYM, HES, KSS, NSF, NSFE, SAP, SPC, VGM, VGZ,
    VTX)
 .
 DSP effects:
  - BS2B effect
  - sample rate converter
  - LADSPA effects
  - extra stereo
  - crossfade
 .
 Visual effects:
  - projectM visualization
  - spectrum analyzer
 .
 Audio output through:
  - ALSA
  - OSS
  - PulseAudio
  - JACK
  - QTMultimedia
  - Icecast
 .
 Other features:
  - XMMS and Winamp 2.x skins support
  - alternative user interface based on standard widgets set
  - 10-band equalizer
  - MP3, Vorbis, AAC, AAC+ streams support
  - mms support
  - MPRIS
  - removable device detection (via HAL or UDisks)
  - video playback via Mplayer
  - lyrics (using LyricWiki and other providers)
  - cover art support
  - CUE sheet support
  - embedded CUE support (for FLAC, WavPack and Monkey's Audio)
  - multiple playlists
  - automatic charset detection for cue files and ShoutCast metadata
  - playlist formats: m3u, pls, xspf
  - ReplayGain support
  - sending listening history to Last.fm, Libre.fm and ListenBrainz
  - CDDB support
  - audio converter
  - stream browser
  - audio formats converter
  - external programs execution on track change
  - ReplayGain scanner
  - archive reader (RAR and 7z)
  - audio recording
  - listening history

Package: qmmp-plugin-projectm
Architecture: any-amd64 any-arm64 i386 any-mips64el any-mipsel any-ppc64el any-s390x any-alpha any-hppa any-ia64 kfreebsd-any any-m68k any-powerpc any-ppc64 any-riscv64 any-sh4 any-sparc64 any-x32
Depends: ${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core
Description: qmmp audio player -- projectM visualization plugin
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 See 'qmmp' package for full description.
 .
 This package contains projectM visualization plugin for qmmp.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

ifeq ($(DEB_HOST_ARCH_OS),linux)
	EXTRA_CMAKE_ARGS = -DUSE_HAL:BOOL=FALSE -DUSE_OSS4:BOOL=FALSE
else
	EXTRA_CMAKE_ARGS = -DUSE_ALSA:BOOL=FALSE -DUSE_UDISKS:BOOL=FALSE
endif

# For hardening (CPPFLAGS is not taken into account by upstream's build system)
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr \
	  -DCMAKE_INSTALL_LIBDIR=lib/qmmp \
	  -DPLUGIN_DIR=lib/qmmp/plugins \
	  -DCMAKE_INSTALL_RPATH=/usr/lib/qmmp \
	  -DCMAKE_BUILD_WITH_INSTALL_RPATH:BOOL=TRUE \
	  $(EXTRA_CMAKE_ARGS)

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1

override_dh_install:
ifneq (,$(filter-out armel armhf,$(DEB_HOST_ARCH)))
	dh_install -pqmmp-plugin-projectm
endif
	chmod +x debian/tmp/usr/share/qmmp/scripts/kwin.sh
	dh_install -Xprojectm

# Avoid a call to ldconfig in postinst & postrm (ldconfig is not needed since we
# only install private libraries)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# dh_auto_clean doesn't call make distclean automatically from the CMake build
# directory, so we have to remove leftover .qm files manually
override_dh_auto_clean:
	find -name '*.qm' | xargs rm -fv
	dh_auto_clean
